
; 
;
;                   FLIP-FLOP zmna disketovch mechanik A a B
;
; 

Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         ORG       100h

; -----------------------------------------------------------------------------
;        instalan st
; -----------------------------------------------------------------------------

; ------ zobrazen vzvy

Start:   mov       dx,offset VyzvaTxt
         mov       ah,9
         int       21h

; ------ ekn na zadn znaku

         mov       ah,0
         int       16h

; ------ konverze znaku na velk psmeno

         cmp       al,"a"
         jb        Start1
         cmp       al,"b"
         ja        Start1
         and       al,not 20h               ; konverze na velk psmeno

; ------ slo mechaniky

Start1:  sub       al,"A"                   ; slo mechaniky
         jc        Start9
         cmp       al,2
         jae       Start9                   ; nen oznaen disku
         xchg      ax,dx                    ; DL <- zadan slo mechaniky

; ------ naten BOOT sektoru

         mov       ah,2
         call      int13                    ; naten sektoru
         jnc       Start3                   ; sektor naten OK
         mov       dx,offset ReadTxt        ; text - chyba ten
         jmp       short Start8

; ------ modifikace BOOT sektoru

Start3:  mov       si,offset Boot           ; nov BOOT sektor
         mov       di,offset Buffer         ; buffer s natenm BOOT sektorem
         mov       cx,11                    ; dlka vodn sti
         cld
         rep       movsb                    ; penos vodn sti

         mov       di,offset Buffer + 3eh   ; zatek druh sti
         mov       cx,offset(RezEnd-Boot1)  ; dlka druh sti
         rep       movsb                    ; penos druh sti

         mov       word ptr ds:[Buffer + 512 - 2],0aa55h ; identifiktor BOOT

; ------ zpis BOOT sektoru

         mov       ah,3
         call      int13                    ; zpis sektoru
         jnc       Start9                   ; sektor zapsn OK
         mov       dx,offset WritTxt        ; text - chyba zpisu

; ------ chybov hlen

Start8:  mov       ah,9
         int       21h                      ; zobrazen chybovho hlen
Start9:  int       20h

; ------ texty

VyzvaTxt db        'FlipFlop V1.0 - zamena disketovych mechanik A: a B:; (c) Miroslav Nemecek',13,10
         db        '  Program ulozi na disketu novy zavadeci (BOOT) sektor. Startem pocitace',13,10
         db        '  z teto diskety bude zamenena disketova mechanika A: a B:,',13,10
         db        '  takze zavedeni systemu probehne z disketove mechaniky B:.',13,10
         db        13,10
         db        'Stisknete A nebo B = disketa, kam se novy BOOT sektor ulozi.',13,10,'$'

ReadTxt  db        'Chyba cteni z diskety !',13,10,'$'
WritTxt  db        'Chyba zapisu na disketu !',13,10,'$'

; ------ obsluha INT 13h

Int13:   mov       bp,3                     ; ta pokus

Int131:  push      ax
         push      dx
         push      ds
         push      es
         push      bp

         mov       dh,0                     ; strana 0
         mov       cx,1                     ; vlec 0, sektor 1
         mov       al,1                     ; 1 sektor
         mov       bx,offset Buffer         ; buffer se sektorem

         int       13h

         pop       bp
         pop       es
         pop       ds
         pop       dx
         pop       ax

         jnc       Int134                   ; operace OK
         dec       bp                       ; ta pokus
         jnz       Int131                   ; dal pokus
Int134:  ret

; -----------------------------------------------------------------------------
;        BOOT sektor (adresa 7C00h)
; -----------------------------------------------------------------------------

BootKor  EQU       7C3Eh - offset(Boot1-Start) - 100h ; korekce adresy BOOT

Boot     db        0ebh,3ch,90h             ; instrukce JMP 7C3Eh, NOP
         db        'FlipFlop'

; Adresa 7C3Eh

; ------ inicializace registr

Boot1:   xor       ax,ax                    ; AX <- 0
         mov       ss,ax                    ; SS <- 0
         mov       sp,7c00h                 ; zsobnk pod zavadem
         mov       ds,ax                    ; DS <- 0
         mov       es,ax                    ; ES <- 0

; ------ schova vektoru peruen INT 13h

         cld
         mov       si,13h*4                 ; pvodn adresa INT 13h
         mov       di,offset Old13 + BootKor ; buffer k schov adresy INT 13h
         movsw                              ; schova pvodn adresy INT 13h
         movsw

; ------ snen konce voln pamti

         mov       ax,ds:[413h]             ; velikost pamti v KB
         dec       ax                       ; rezerva 1 KB v pamti
         mov       ds:[413h],ax             ; nov velikost pamti

; ------ adresa rezidentn sti programu

         mov       cl,6                     ; poet rotac pro pepoet
         shl       ax,cl                    ; pepoet na adresu
         mov       es,ax                    ; ES <- adresa rezidentu
         xor       di,di                    ; DI <- offset rezidentu

; ------ nadefinovn nov adresy INT 13h

         mov       ds:[4*13h],di            ; offset nov adresy rezidentu
         mov       ds:[4*13h+2],ax          ; segment nov adresy rezidentu

; ------ penos rezidentn sti na vrchol pamti

         mov       si,offset RezBeg + BootKor ; zatek rezidentn sti
         mov       cx,offset(RezEnd-RezBeg) ; dlka rezidentn sti
         rep       movsb                    ; penos rezidentn sti nahoru

; ------ zobrazen informanho textu

         mov       si,offset BootTxt + BootKor ; informan text
Boot2:   cld
         lodsb                              ; znak k zobrazen
         cmp       al,0                     ; je konec textu ?
         je        Boot3                    ; je konec textu
         mov       bx,7                     ; bl barva
         mov       ah,0eh
         int       10h                      ; zobrazen znaku
         jmp       short Boot2

; ------ ekn na stisk klvesy

Boot3:   xor       ax,ax                    ; AX <- 0
         int       16h                      ; ekn na stisk klvesy

; ------ pokraovn v zavdn systmu

         int       19h

; ------ informan text

BootTxt  db        13,10
         db        'Disketove mechaniky A: a B: byly zameneny.',13,10
         db        'Vlozte systemovou disketu do druhe mechaniky',13,10
         db        'a stisknete libovolnou klavesu ...',13,10,0

; ------ rezidentn modul

RezBeg   label     byte

         or        dl,dl                    ; je to disketa ?
         js        RezBeg1                  ; nen to disketa
         cmp       ah,8                     ; je poskytnut disket. parametr ?
         jne       RezBeg2                  ; nen poskytnut parametr

         xor       dl,1                     ; zmna disketovch mechanik
RezBeg1: jmp       dword ptr cs:[Old13-RezBeg] ; pokraovn v pvodn obsluze

RezBeg2: push      dx
         xor       dl,1                     ; zmna disketovch mechanik
         pushf
         call      dword ptr cs:[Old13-RezBeg] ; voln poadovan funkce
         pop       dx                       ; nvrat sla disku v DL
         retf      2

Old13    dd        0                        ; pvodn adresa INT 13h

RezEnd   label     byte                     ; konec rezidentn sti

Buffer   label     byte                     ; buffer k naten sektoru

Code     ENDS
         END       Start
